package uy.edu.fing.chesstrack.modulovision.imgproc;

import org.opencv.core.CvType;
import org.opencv.core.Mat;
import org.opencv.core.MatOfPoint2f;
import org.opencv.core.Point;
import org.opencv.imgproc.Imgproc;

public class Homografia implements ImgProcInterface {


	private final   Mat matrizTransformada;

	public Homografia(MatOfPoint2f vertices) {
		super();
		int offset = 48*2;
		int media = 48*6;
		Mat src = new Mat(4,1,CvType.CV_32FC2);
		Mat dst = new Mat(4,1,CvType.CV_32FC2);
		Point p1,p2,p3,p4;
		p1 = vertices.toList().get(0);
		p2 = vertices.toList().get(6);
		p3 = vertices.toList().get(42);
		p4 = vertices.toList().get(48);
		src.put((int)p1.y,(int)p1.x, (int)p2.y,(int)p2.x, (int)p4.y,(int)p4.x, (int)p3.y,(int)p3.x);
		dst.put( offset,offset ,offset+media,offset , offset,offset+media , offset+media,offset+media );

		matrizTransformada = Imgproc.getPerspectiveTransform(src,dst);
	}



	@Override
	public Mat procesarImagen(Mat inputFrame) {
		Mat out = inputFrame.clone();
		Imgproc.warpPerspective(inputFrame,out, matrizTransformada, out.size());
		return inputFrame;
	}


}
